-- File: Events.lua
-- What's for: We use this file for the event detections

local SayKarmaEvent = CreateFrame("Frame");
SayKarmaEvent.playername = UnitName("player");

-- ==================================================
--					EVENT
-- ==================================================
SayKarmaEvent:SetScript("OnEvent", function(_,_,_,event, _,_,sourceName, _,_,_,destName, _,_,spellId)
        -- is SayKarma enable ? just a fast way to disable SayKarma without to reload everything
        -- yes: we check the events
        -- no: we do nothing
        if (SayKarmaPrefs['SayKarmaEnable'] == "yes") then
            -- DeathKnight =====================================================
            if (SayKarmaPrefs['DeathKnightEnable'] == "yes") then           -- do we have to watch spells from DK ?
                -- Asphyxiate
                if ((spellId == 108194)
                    and (SayKarmaPrefs['DeathKnightAsphyxiate'] == "yes")   -- do we have to do an announce for this spell ?
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(108194);
                    SendChatMessage("{rt8} Stunned by this dk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Mind Freeze
                if ((spellId == 47528)                                      -- wowhead.com ID spell
                    and (SayKarmaPrefs['DeathKnightMindFreeze'] == "yes")   -- isEnable ?
                    and (destName == SayKarmaEvent.playername)              -- Am I the victim of this spell ?
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))   -- Applied or Refreshed or Interrupted
                then
                    local splink = GetSpellLink(47528);                     -- get an overmouse link of this spell
                    SendChatMessage("{rt8} Silenced by this dk -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");  -- display a message in /s
                    return;
                end

                -- Strangulate
                if ((spellId == 47476)
                    and (SayKarmaPrefs['DeathKnightStrangulate'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(47476);
                    SendChatMessage("{rt8} Stunned by this dk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End DeathKnight =================================================

            -- Druid ===========================================================
            if (SayKarmaPrefs['DruidEnable'] == "yes") then
                -- FaeSilence
                if ((spellId == 114238)
                    and (SayKarmaPrefs['DruidFaeSilence'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(114238);
                    SendChatMessage("{rt8} Silenced by this druid -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Cyclone
                if ((spellId == 33786)
                    and (SayKarmaPrefs['DruidCyclone'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(33786);
                    SendChatMessage("{rt8} " .. splink .. " on me, by this druid -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Druid =======================================================

            -- Hunter ==========================================================
            if (SayKarmaPrefs['HunterEnable'] == "yes") then
                -- Counter Shot
                if ((spellId == 147362)
                    and (SayKarmaPrefs['HunterCounterShot'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(147362);
                    SendChatMessage("{rt8} Silenced by this hunt -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Freezing Trap
                if ((spellId == 3355)
                    and (SayKarmaPrefs['HunterFreezingTrap'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(3355);
                    SendChatMessage("{rt8} ".. splink .." on me, by this hunt -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Silencing Shot
                if ((spellId == 41084)
                    and (SayKarmaPrefs['HunterSilencingShot'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(147362);
                    SendChatMessage("{rt8} Silenced by this hunt -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Hunter ======================================================

            -- Mage ============================================================
            if (SayKarmaPrefs['MageEnable'] == "yes") then
                -- Counterspell
                if ((spellId == 2139)
                    and (SayKarmaPrefs['MageCounterspell'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(2139);
                    SendChatMessage("{rt8} Silenced by this mage -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Deep Freeze
                if ((spellId == 44572)
                    and (SayKarmaPrefs['MageDeepFreeze'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(44572);
                    SendChatMessage("{rt8} Stunned by this mage "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
               -- Frostjaw
                if ((spellId == 102051)
                    and (SayKarmaPrefs['MageFrostjaw'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(102051);
                    SendChatMessage("{rt8} Silenced by this mage -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Black Cat
                if ((spellId == 61305)
                    and (SayKarmaPrefs['MagePolymorphBlackCat'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(61305);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Monkey
                if ((spellId == 161354)
                    and (SayKarmaPrefs['MagePolymorphMonkey'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(161354);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Peacock
                if ((spellId == 161372)
                    and (SayKarmaPrefs['MagePolymorphPeacock'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(161372);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Penguin
                if ((spellId == 161355)
                    and (SayKarmaPrefs['MagePolymorphPenguin'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(161355);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Polar Bear Cub
                if ((spellId == 161353)
                    and (SayKarmaPrefs['MagePolymorphPolarBearCub'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(161353);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Pig
                if ((spellId == 28272)
                    and (SayKarmaPrefs['MagePolymorphPig'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(28272);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Rabbit
                if ((spellId == 61721)
                    and (SayKarmaPrefs['MagePolymorphRabbit'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(61721);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end

                -- Polymorph - Sheep
                if ((spellId == 118)
                    and (SayKarmaPrefs['MagePolymorphSheep'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(118);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Turkey
                if ((spellId == 61780)
                    and (SayKarmaPrefs['MagePolymorphTurkey'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(61780);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Turtle
                if ((spellId == 28271)
                    and (SayKarmaPrefs['MagePolymorphTurtle'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(28271);
                    SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Mage ========================================================

            -- Monk ============================================================
            if (SayKarmaPrefs['MonkEnable'] == "yes") then
                -- Leg Sweep
                if ((spellId == 119381)
                    and (SayKarmaPrefs['MonkLegSweep'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(119381);
                    SendChatMessage("{rt8} Stunned by this monk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Paralysis
                if ((spellId == 115078)
                    and (SayKarmaPrefs['MonkParalysis'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(115078);
                    SendChatMessage("{rt8} Stunned by this monk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Spear Hand Strike
                if ((spellId == 116705 or spellId == 173320)
                    and (SayKarmaPrefs['MonkSpearHandStrike'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(116705);
                    SendChatMessage("{rt8} Silenced by this monk -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Touch of Karma
                if ((spellId == 122470)
                    and (SayKarmaPrefs['MonkTouchOfKarma'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(122470);
                    SendChatMessage("{rt8} " .. splink .. " on me (10s). Stop dps this monk -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Monk ========================================================

            -- Paladin =========================================================
            if (SayKarmaPrefs['PaladinEnable'] == "yes") then
                -- Fist of Justice
                if ((spellId == 105593)
                    and (SayKarmaPrefs['PaladinFistOfJustice'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(105593);
                    SendChatMessage("{rt8} Stunned by this paladin "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Hammer of Justice
                if ((spellId == 853)
                    and (SayKarmaPrefs['PaladinHammerOfJustice'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(853);
                    SendChatMessage("{rt8} Stunned by this paladin "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Rebuke
                if ((spellId == 96231)
                    and (SayKarmaPrefs['PaladinRebuke'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(96231);
                    SendChatMessage("{rt8} Silenced by this paladin -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Repentance
                if ((spellId == 20066)
                    and (SayKarmaPrefs['PaladinRepentance'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(20066);
                    SendChatMessage("{rt8} Stunned by this paladin -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Paladin =====================================================

            -- Priest ==========================================================
            if (SayKarmaPrefs['PriestEnable'] == "yes") then
                -- Dominate Mind
                if ((spellId == 605)
                    and (SayKarmaPrefs['PriestDominateMind'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(605);
                    SendChatMessage("{rt8} ".. splink .." on me, cc this priest -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end

                -- Holy Word: Chastise
                if ((spellId == 88625)
                    and (SayKarmaPrefs['PriestHolyWordChastise'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(88625);
                    SendChatMessage("{rt8} Stunned by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Psychic Horror
                if ((spellId == 64044)
                    and (SayKarmaPrefs['PriestPsychicHorror'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(64044);
                    SendChatMessage("{rt8} Feared by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Silence
                if ((spellId == 15487)
                    and (SayKarmaPrefs['PriestSilence'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(15487);
                    SendChatMessage("{rt8} Silenced by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

            end
            -- End Priest ======================================================

            -- Rogue ===========================================================
            if (SayKarmaPrefs['RogueEnable'] == "yes") then
                -- Blind
                if ((spellId == 2094)
                    and (SayKarmaPrefs['RogueBlind'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(2094);
                    SendChatMessage("{rt8} " .. splink .. " on me, by this rogue -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end

                -- Garrote
                if ((spellId == 1330)
                    and (SayKarmaPrefs['RogueGarrote'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(1330);
                    SendChatMessage("{rt8} Silenced by this rogue -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                if ((spellId == 703)
                    and (SayKarmaPrefs['RogueGarrote'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(703);
                    SendChatMessage("{rt8} Silenced by this rogue -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- kick
                if ((spellId == 1766)
                    and (SayKarmaPrefs['Roguekick'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(1766);
                    SendChatMessage("{rt8} Silenced by this rogue -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Sap
                if ((spellId == 6770)
                    and (SayKarmaPrefs['RogueSap'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(6770);
                    SendChatMessage("{rt8} Sapped, by this rogue -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Rogue =======================================================

            -- Shaman ==========================================================
            if (SayKarmaPrefs['ShamanEnable'] == "yes") then
                -- Hex
                if ((spellId == 51514)
                    and (SayKarmaPrefs['ShamanHex'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(51514);
                    SendChatMessage("{rt8} ".. splink .." on me, by this shaman -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end

                -- Wind Shear
                if ((spellId == 57994)
                    and (SayKarmaPrefs['ShamanWindShear'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(57994);
                    SendChatMessage("{rt8} Silenced by this shaman -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Shaman ======================================================

            -- Warlock =========================================================
            if (SayKarmaPrefs['WarlockEnable'] == "yes") then
                -- Mesmerize
                if ((spellId == 115268)
                    and (SayKarmaPrefs['WarlockMesmerize'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(115268);
                    SendChatMessage("{rt8} Seduced, cc that succube asap ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Seduction
                if ((spellId == 6358)
                    and (SayKarmaPrefs['WarlockSeduction'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(6358);
                    SendChatMessage("{rt8} Seduced, cc that succube asap ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Warlock =====================================================

            -- Warrior =========================================================
            if (SayKarmaPrefs['WarriorEnable'] == "yes") then
                -- Dragon Roar
                if ((spellId == 118000)
                    and (SayKarmaPrefs['WarriorDragonRoar'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(118000);
                    SendChatMessage("{rt8} Silenced by this war -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Pummel
                if ((spellId == 6552)
                    and (SayKarmaPrefs['WarriorPummel'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(6552);
                    SendChatMessage("{rt8} Silenced by this war -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Shockwave
                if ((spellId == 132168) -- or ((spellId == 46968)
                    and (SayKarmaPrefs['WarriorShockwave'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(132168);
                    SendChatMessage("{rt8} Stunned by this war "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Storm Bolt
                if ((spellId == 107570)
                    and (SayKarmaPrefs['WarriorStormBolt'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(107570);
                    SendChatMessage("{rt8} Stunned by this war "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Storm Bolt Off-Hand
                if ((spellId == 145585)
                    and (SayKarmaPrefs['WarriorStormBoltOffHand'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local splink = GetSpellLink(145585);
                    SendChatMessage("{rt8} Stunned by this war "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Warrior =====================================================

        end -- if (SayKarmaPrefs['SayKarmaEnable'] == "yes") then
    end -- function(_,_,_,event, _,_,sourceName, _,_,_,destName, _,_,spellId)
); -- SayKarmaEvent:SetScript(

SayKarmaEvent:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
